//+------------------------------------------------------------------+
//|                                              HEDGEVOT - beta.mq4 |
//|                             Copyright  2006, Mikhail Veneracion |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Mikhail Veneracion"
#property link      ""

#include <stdlib.mqh>
#include <WinUser32.mqh>
//-------EXTERN VARS
extern string  
         Expert_Name          = ".o0($$$ HEDGEVOT - Beta1 $$$)0o.";
extern string 
         General_Options      = "---------GENERAL OPTIONS--------";
         
extern double  Lots = 1.0;
extern int     MagicNumber = 2020;
extern int     Slippage = 3;
extern int     NumberOfTries = 10;

extern string  PivotOps      =  "----------PIVOT OPTIONS---------";

extern double  PivotMin = 80; //minimum required difference of High and Low
extern double  PivotMax = 120;//Maximum limit difference of High and Low
extern int     BarLookBack = 6; //how many bars to lookback for calcualting Pivot
extern int     ReEntryPips = 12; //pip distance before re-entry 

//-------GLOBAL VARIABLES
static int 
         TimeFrame            = 0;
bool Init = true;
double Pivot, R1, R2, R3, S1, S2, S3, MAX, MIN, CLOSE, Spot,HighLowDiff,Spread,HedgePrice,ZonePrice;
int cnt, ticket, ticket1, ticket2, total;
string HedgePoint, Zone;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   //----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----



//-----------GET MARKET VALUES

total  = subTotalTrade();
Spread = NormalizeDouble(((Bid-Ask)/2),4);
Spot = NormalizeDouble(((Bid+Ask)/2),4);
 
int highest_bar=Highest(NULL, PERIOD_H1, MODE_HIGH, BarLookBack, 0);
MAX=iHigh(NULL, PERIOD_H1, highest_bar);

int lowest_bar=Lowest(NULL, PERIOD_H1, MODE_LOW, BarLookBack, 0);
MIN=iLow(NULL, PERIOD_H1, lowest_bar);

CLOSE = iClose(NULL, PERIOD_H1, 0);
   
HighLowDiff = ((MAX - MIN)/Point);

Print("Init ="+Init);
Print("total ="+total);
Print("HedgePoint ="+HedgePoint);
Print("ZOne=" +Zone);

//-------------CALCULATE PIVOT POINTS


if(Init)
{
   total = subTotalTrade();
   if (total<1)
   {
      Zone = "NULL";
      ZonePrice = 0;
      HedgePoint = "NULL";
      ticket1=0;
      ticket2=0;
      subDelPivot();  
   }
}

if(Init)
{  
   if((HighLowDiff>=PivotMin)&&(HighLowDiff<=PivotMax))
   {
      total  = subTotalTrade();
      if(total < 1)
      {
         subCalcPivot();
         Init = false;
      }
   }
}   
subPrintDetails();

//------------LOOK FOR OPEN HEDGE ENTRY POINTS 
   if((Spot == Pivot)||(Bid == Pivot)||(Ask == Pivot))
   { 
      
      total = subTotalTrade();
      if(HedgePoint=="NULL")
      {  
         
         ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R1);
         if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R1);
         if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R1);
         ticket2= subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S1);
         if(ticket2<=0)ticket2= subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S1);
         if(ticket2<=0)ticket2= subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S1);
         HedgePoint = "Pivot";
         HedgePrice = Pivot;
         Alert("Open Hedge at "+HedgePoint);
         
      }
   }   
   if((Spot == R1)||(Bid == Pivot)||(Ask == Pivot))
   { 
      
      total = subTotalTrade();
      if(HedgePoint=="NULL")
      {  
         ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R2);
         if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R2);
         if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R2);
         
         ticket2= subOpenOrder(OP_SELL,R3+ReEntryPips*Point,Pivot);
         if(ticket2<=0)ticket2= subOpenOrder(OP_SELL,R3+ReEntryPips*Point,Pivot);
         if(ticket2<=0)ticket2= subOpenOrder(OP_SELL,R3+ReEntryPips*Point,Pivot);
         HedgePoint = "R1";
         HedgePrice = R1;
         Alert("Open Hedge at "+HedgePoint);
         
      }
   
   }   
   if((Spot == S1)||(Bid == Pivot)||(Ask == Pivot))
   { 
       
      total = subTotalTrade();
      if(HedgePoint=="NULL")
      {  
         ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,Pivot);
         if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,Pivot);
         if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,Pivot);
         ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S2);
         if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S2);
         if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S2);
         HedgePoint = "S1";
         HedgePrice = S1;
         Alert("Open Hedge at "+HedgePoint);
         
      } 
   }
   if((total>0)||(R3+ReEntryPips*Point<=Spot)||(S3-ReEntryPips*Point>=Spot)){
   Init = True;
   } 

//-------------------------------------------------------------------+
//---------------------IDNETIFY TRADING ZONES------------------------+
   if((Spot==R3)||(Ask==R3)||(Bid==R3)){
      Zone = "R3";
      ZonePrice = R3;
      total=subTotalTrade();
 
   }
   if((Spot==R2)||(Ask==R2)||(Bid==R2)){
      total  = subTotalTrade();
      Zone = "R2";
      ZonePrice = R2;
   }
   if((Spot==R1)||(Ask==R1)||(Bid==R1)){
      Zone = "R1";
      ZonePrice = R1;
      total  = subTotalTrade();
   }
   if((Spot==Pivot)||(Ask==Pivot)||(Bid==Pivot)){
      Zone = "Pivot";
      ZonePrice = Pivot;
      total  = subTotalTrade();
   }
   if((Spot==S1)||(Ask==S1)||(Bid==S1)){
      Zone = "S1";
      ZonePrice = S1;
      total  = subTotalTrade();
   }
   if((Spot==S2)||(Ask==S2)||(Bid==S2)){
      Zone = "S2";
      ZonePrice = S2;
      total  = subTotalTrade();
   }
   if((Spot==S3)||(Ask==S3)||(Bid==S3)){
      Zone = "S3";
      ZonePrice = S3;
      total  = subTotalTrade();
   }

//----------------MODIFY ORDER----------------------------------------+
  if(subTotalTrade()==1)
   {  
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
         {
             HedgePoint = subModifyOrder(OrderType());
         }
         total  = subTotalTrade();
      }
   } 
   
//----------------ORDER REENTRY--------------------------------------+

if(subTotalTrade()==1)
   {  
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if(
            OrderSymbol()==Symbol() &&
            OrderMagicNumber()==MagicNumber)
         {
             subReEntry(OrderType());
         }
         total  = subTotalTrade();
      }
   } 

//-------------------------------------------------------------------+
   return(0);
}
//-------------------------------------------------------------------+

  
//-------------------------------------------------------------------+
//-----------------------END OF PROGRAM------------------------------+
//+------------------------------------------------------------------+

//----------------------- CALCULATE PIVOT POINTS
//----------------------- SOURCE : MIKHAILDGREAT

void subCalcPivot()
{
Pivot = NormalizeDouble((( MAX + CLOSE + MIN ) / 3),4);   
    
R1 = NormalizeDouble(2 * Pivot - MIN,4); //normal trading range 
S1 = NormalizeDouble(((2 * Pivot) - MAX),4); //for the next period 
    
R2 = NormalizeDouble((Pivot + (R1 - S1)),4); //extreme trading range 
S2 = NormalizeDouble((Pivot - (R1 - S1)),4);   
    
R3 = NormalizeDouble((MAX + (2*(Pivot - MIN))),4 );  
S3 = NormalizeDouble((MIN - (2*(MAX - Pivot))),4) ;  

Alert("New PIVOT points Defined");
}

//----------------------- RESET PIVOT POINTS
void subDelPivot()
{
Pivot = 0.0;   
    
R1 = 0.0; //normal trading range 
S1 = 0.0; //for the next period 
    
R2 = 0.0; //extreme trading range 
S2 = 0.0;   
    
R3 = 0.0;  
S3 = 0.0;  

}
//-----------------------
//----------------------- OPEN HEDDGE FUNCTION

//----------------------- PRINT COMMENT FUNCTION
//----------------------- SOURCE : CODERSGURU
void subPrintDetails()
{
   string sComment   = "";
   string sp         = "-------------------------------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + "R1= " + DoubleToStr(R1,4) + " | ";
   sComment = sComment + "R2= " + DoubleToStr(R2,4) + " | ";
   sComment = sComment + "R3= " + DoubleToStr(R3,4) + NL; 
   sComment = sComment + sp;
   sComment = sComment + "PIVOT= " + DoubleToStr(Pivot,4) + NL; 
   sComment = sComment + sp;
   sComment = sComment + "S1= " + DoubleToStr(S1,4) + " | ";
   sComment = sComment + "S2= " + DoubleToStr(S2,4) + " | ";
   sComment = sComment + "S3= " + DoubleToStr(S3,4) + NL; 
   sComment = sComment + sp;
   sComment = sComment + "HIGH= " + DoubleToStr(MAX,4) + " | ";
   sComment = sComment + "LOW= " + DoubleToStr(MIN,4) + " | ";
   sComment = sComment + "DIFF= " + DoubleToStr(HighLowDiff,0) + NL; 
   sComment = sComment + sp;
   Comment(sComment);
}
//----------------------- Modify Order Function
string subModifyOrder(int Type)
{
   if(Type==OP_BUY)
   {total  = subTotalTrade();
      if ((HedgePoint=="R2")&&(Zone == "R1")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),R2,0,GreenYellow);
             HedgePoint = "R1";
      }
      if ((HedgePoint=="R1")&&(Zone == "Pivot")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),R1,0,GreenYellow);
             HedgePoint = "Pivot";
      }
      if ((HedgePoint=="Pivot")&&(Zone == "S1")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Pivot,0,GreenYellow);
             HedgePoint = "S1";
      }
      if ((HedgePoint=="S1")&&(Zone == "S2")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),S1,0,GreenYellow);
             HedgePoint = "S2";
      }
      if ((HedgePoint=="S2")&&(Zone == "S3")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),S2,0,GreenYellow);
             HedgePoint = "S3";
      }
   }
   if(Type==OP_SELL)
   {total  = subTotalTrade();
      if ((HedgePoint=="R1")&&(Zone == "R2")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),R1,0,GreenYellow);
             HedgePoint = "R2";
      }
      if ((HedgePoint=="Pivot")&&(Zone == "R1")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Pivot,0,GreenYellow);
             HedgePoint = "R1";
      }
      if ((HedgePoint=="S1")&&(Zone == "Pivot")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),S1,0,GreenYellow);
             HedgePoint = "Pivot";
      }
      if ((HedgePoint=="S2")&&(Zone == "S1")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),S2,0,GreenYellow);
             HedgePoint = "S1";
      }
      if ((HedgePoint=="R2")&&(Zone == "R3")){
             OrderModify( OrderTicket(),OrderOpenPrice(),OrderStopLoss(),R2,0,GreenYellow);
             HedgePoint = "R3";
      }
   }
   return(HedgePoint);
}
//----------------------- REENTRY FUNCTION

//----------------------- Modify Order Function
void subReEntry(int Type)
{
   if(Type==OP_BUY)
   {total  = subTotalTrade();
      if ((HedgePoint=="R2")&&(Zone == "R2")){
             
             ticket2=0;
             if((ZonePrice-ReEntryPips*Point)>=Spot){
                           ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,R1);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,R1);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,R1);
             }
            
      }
      if ((HedgePoint=="R1")&&(Zone == "R1")){
             
             ticket2=0;
             if((ZonePrice-ReEntryPips*Point)>=Spot){
                           ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,Pivot);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,Pivot);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,Pivot);
             }
            
      }
      if ((HedgePoint=="Pivot")&&(Zone == "Pivot")){
             
             ticket2=0;
             if((ZonePrice-ReEntryPips*Point)>=Spot){
                           ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S1);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S1);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S1);
             }
            
      }
      if ((HedgePoint=="S1")&&(Zone == "S1")){
             
             ticket2=0;
             if((ZonePrice-ReEntryPips*Point)>=Spot){
                           ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S2);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S2);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S2);
             }
             
      }
      if ((HedgePoint=="S2")&&(Zone == "S2")){
             
             
             ticket2=0;
             if((ZonePrice-ReEntryPips*Point)>=Spot){
                           ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S3);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S3);
                              if(ticket2<=0)ticket2 = subOpenOrder(OP_SELL,R3+ReEntryPips*Point,S3);
             }
      }

   }
   if(Type==OP_SELL)
   {total  = subTotalTrade();
     if ((HedgePoint=="S2")&&(Zone == "S2")){

             ticket1=0;
             if((ZonePrice+ReEntryPips*Point)<=Spot){
                    ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips,Pivot);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,S1);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,S1);
             }
      }
     if ((HedgePoint=="S1")&&(Zone == "S1")){

             ticket1=0;
             if((ZonePrice+ReEntryPips*Point)<=Spot){
                    ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips,Pivot);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,Pivot);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,Pivot);
             }
      }
      if ((HedgePoint=="R2")&&(Zone == "R2")){

             ticket1=0;
             if((ZonePrice+ReEntryPips*Point)<=Spot){
                    ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips,R3);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R3);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R3);
             }
      }
      if ((HedgePoint=="R1")&&(Zone == "R1")){

             ticket1=0;
             if((ZonePrice+ReEntryPips*Point)<=Spot){
                    ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips,R2);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R2);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R2);
             }
      }
      if ((HedgePoint=="Pivot")&&(Zone == "Pivot")){
             ticket1=0;
             if((ZonePrice+ReEntryPips*Point)<=Spot){
                    ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips,R1);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R1);
                    if(ticket1<=0)ticket1 = subOpenOrder(OP_BUY,S3-ReEntryPips*Point,R1);
             }
      }
   }
   return(0);
}
//----------------------- END OF REENTRY FUNCTION
//----------------------- NUMBER OF ORDER BASE ON SYMBOL AND MAGICNUMBER FUNCTION
int subTotalTrade()
{
   int
      cnts, 
      totals = 0;

   for(cnts=0;cnts<OrdersTotal();cnts++)
   {
      OrderSelect(cnts,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) totals++;
   }
   return(totals);
}
//--------------------------OPEN ORDER FUNCTION
int subOpenOrder(int type, double stoploss, double takeprofit)
{
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
          
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,stoploss,takeprofit,"HEDGEVOT",MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,stoploss,takeprofit,"HEDGEVOT",MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }  
   return(ticket);
}
//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE
int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) MagicNumber = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
}

